


//		WINDOWJUMP
//	By DaVince & FireTalon





var spriteset = "test.rss";
var person = "player";
var map = "World1.rmp";

var jumpkey = KEY_CTRL;
var leftkey = KEY_LEFT;
var rightkey= KEY_RIGHT;



function game()
{
	CreatePerson(person, spriteset, false);
	AttachCamera(person);
	SetDefaultMapScript(SCRIPT_ON_ENTER_MAP, "SetRenderScript(\"PlatformEngine()\");");
	MapEngine(map, 60);
}





//Renderscript!
function PlatformEngine()
{
	GameControls();
	//EnemyAI();
	
}







var JumpHeight = 9;		//Max jump height.
var gravity = 0.5;		//With how many steps the engine changes velocity
var velocity = 0;			//How fast the player falls down
var jumping = false;

var x = 0;
var y = 0;

var xSpeed = 1;		//Current walk speed.



function GameControls()
{
	x = GetPersonX(person);
	y = GetPersonY(person);
	
	
	//		JUMPING
	//================
	if (IsKeyPressed(jumpkey) && !jumping) jumping = true, velocity = -1*JumpHeight;
	
	if (jumping && !IsPersonObstructed(person,x,y))
	{
		if (velocity < 10) velocity += gravity;
		SetPersonY(person, y + velocity);
	}
	
	
	//When hitting the floor
	if (IsPersonObstructed(person,x,y+velocity))
	{
		var test = 0;
		for (var i = 0; IsPersonObstructed(person,x,(y+velocity)-test); i++)
			test++;
		
		jumping = false;
		SetPersonY(person, (y+velocity)-test);
	}
	
	if (!IsPersonObstructed(person, x, y+velocity) && !jumping)
		velocity = 0,
		jumping = true;
	
	
	
	//		WALKING
	//================
	if (IsKeyPressed(leftkey))  xSpeed = -2;
	if (IsKeyPressed(rightkey)) xSpeed = 2;
	
	if (xSpeed != 0 && !IsKeyPressed(rightkey) && !IsKeyPressed(leftkey)) xSpeed = 0;
	if (xSpeed != 0) SetPersonX(person, x+xSpeed);
	
	
	y = GetPersonY(person);
	
	
	//Horizontal collision
	if (IsPersonObstructed(person, x+xSpeed, y))
		SetPersonX(person, GetPersonX(person) - xSpeed);
	
	
	else if (IsPersonObstructed(person, x-xSpeed, y))
		SetPersonX(person, GetPersonX(person) + xSpeed);
	
	
	//Head collision
	if (IsPersonObstructed(person, x, y-5))
		velocity = 1;
}






